/***************************************************************************
 *   Copyright (C) 2006 by Parthasarathy   *
 *   sarathy@Zion   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


/* 
	Method to sort the given data. The unsorted data, the 
	algorithm to be used and the sorting order must be specified.
	This is the only externally visible method in this file.
*/
extern void sort_data (long **unsorted_data, long n, int algorithm, int ascending);

/* Sort data using insertion sort.*/
static void insertion_sort(long **unsorted_data_ptr, long n, int ascending);

/* Sort data using selection sort.*/
static void selection_sort (long **unsorted_data_ptr, long n, int ascending);

/* Sort data using merge sort.*/
static void merge_sort(long **unsorted_data, long start, long end, int ascending);

/* Recursive merge of data.*/
static void merge (long **unsorted_data_ptr, long idx_start, long idx_middle, long idx_end, int ascending);

/* Sort data using recursive insertion sort.*/
static void insertion_recursive_sort(long **unsorted_data_ptr, long n, int ascending);

/* Sort data using bubble sort.*/
static void bubble_sort(long **unsorted_data_ptr, long n, int ascending);

/* Sort data using the quick sort.*/
static void quick_sort(long **unsorted_data_ptr, long lb, long up, int ascending);

/* Function used to partition data in quicksort.*/
static void partition(long **unsorted_data_ptr, long lb, long ub, long *pivot_position, int ascending);
