/***************************************************************************
 *   Copyright (C) 2006 by Parthasarathy   *
 *   sarathy@Zion   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

# include <stdio.h>
# include <stdlib.h>
# include <string.h>

# include <constants.h>
# include <input.h>

/*
        Loads the data from the external file with filename to the
        memory pointed by data.
*/
void load_data (char *filename, long n, char delimiter, long **data)
{
	FILE *data_file = fopen(filename,"r");
	long *data_array = *data;
	char *data_string= (char *) malloc (MAX_DATA_LENGTH);

	int i=0;
	int c;
	int data_length_count=0;

	while ((c=getc(data_file))!=EOF )
	{
		if (c!=TERMINATOR)
		{
			if (c==DELIMITER_SPACE)
			{
				*data_array = atol(data_string);
				//printf ("%ld %ld\n",++i,*data_array);
				data_array++;
				data_length_count=0;
			}
			else
			{
				*(data_string + data_length_count)=c;
				data_length_count++;
				*(data_string + data_length_count)='\0';
			}
		}
		else
			break;
	}
	fclose(data_file);
}

/*
        Creates the data using rand() and saves it to the external file
        with filename.
        n          - is the total number of entries to be created.
        delimiter  - is the delim to be used in the file.
        compressor - the amount by which the data size must be reduced [ uses >> ]
*/
void create_data (char *filename, long n, char delimiter, int compressor)
{
	long cnt_data=1;
	FILE *data_file = fopen(filename,"w+");
	
	while (cnt_data <= n)
	{
		fprintf (data_file,"%ld ",rand()>>compressor);
		cnt_data++;
	}

	fprintf (data_file,"%c",TERMINATOR);
	fclose(data_file);
}


