/***************************************************************************
 *   Copyright (C) 2006 by Parthasarathy   *
 *   sarathy@Zion   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

# include <stdio.h>
# include <stdlib.h>
# include <string.h>

# include <constants.h>
# include <output.h>

/*
        Function to display the data in memory location **data_ptr
        in console.
*/
void console_output(long **data_ptr, long n)
{
	int cnt_data=1;
	long *data = *data_ptr;
	
	while (cnt_data <= n)
	{
		fprintf (stdout,"%ld %ld\n",cnt_data, *data);
		cnt_data++;
		data++;
	}
}

/*
        Function to display the data in memory location **data_ptr
        to file with filename.
*/
void file_output(char *filename,long **data_ptr, long n)
{
	int cnt_data=1;
	long *data = *data_ptr;
	FILE *output_file = fopen(filename, "w+");
	
	while (cnt_data <= n)
	{
		fprintf (output_file,"%ld ",*data);
		cnt_data++;
		data++;
	}

	fprintf (output_file,"%c",TERMINATOR);
	fclose(output_file);
}

/* Function to display the help/usage message.*/
void display_help(void)
{
        printf ("Usage: sort -i input_file [-o output_file] [-s stats_file] -n [-c] -a algorithm [-r compressor] [-x] [-v] [-h]\n\n");
        printf ("-i input_file  Input data file to be sorted.\n");
        printf ("-o output_file Output data file containing sorted data.\n");
        printf ("-s stats_file  Sorting statistics data.\n");
        printf ("-n length      The total number of items to be sorted\n");
        printf ("-d order	0 - ascending , 1 - descending\n");
        printf ("-c             Create new data in input_file and load it for sorting.\n");
        printf ("-x             Do not sort. Exit after creating new data in the input_file. Implies -c\n");
        printf ("-v             Verify the results after sorting.\n");
        printf ("-a algorithm   Sorting al Input data file to be sorted.\n");
	printf ("		1 - Insertion Sort\n"); 
	printf ("		2 - Selection Sort\n"); 
	printf ("		3 - Merge Sort\n"); 
	printf ("		4 - Insertion Recursive sort\n"); 
	printf ("		5 - Bubble sort\n");
	printf ("		6 - Quick sort\n");

        printf ("-r compressor  Amount by which the data size will be reduced using >> operator\n");
        printf ("-h Display help and exit\n");
}
